#if !defined(AFX_MAILSENDER_H__C0802004_FC90_480E_AFE4_70E5CE659D4D__INCLUDED_)
#define AFX_MAILSENDER_H__C0802004_FC90_480E_AFE4_70E5CE659D4D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MailSender.h : header file
//

#include <afxctl.h>

#include "Smtp.h"

#include "CmdTargetPlus.h"
/////////////////////////////////////////////////////////////////////////////
// MailSender command target
class MailSender;

class MySMTPConnection : public CSMTPConnection
{
public:
	MySMTPConnection(MailSender* pMailSender);
	virtual ~MySMTPConnection();
	virtual BOOL OnSendProgress(DWORD dwCurrentBytes, DWORD dwTotalBytes);

private:
	MailSender* m_pMailSender;

};

class MailSender : public CmdTargetPlus
{
	DECLARE_DYNCREATE(MailSender)

	MailSender();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MailSender)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~MailSender();

	// Generated message map functions
	//{{AFX_MSG(MailSender)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG


	DECLARE_EVENT_MAP()
	DECLARE_MESSAGE_MAP()
	DECLARE_OLECREATE(MailSender)
	DECLARE_OLETYPELIB(MailSender)
	HRESULT GetClassID(LPCLSID pclsid);

	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(MailSender)
	long m_nPort;
	CString m_sHost;
	CString m_sUsername;
	CString m_sPassword;
	CString m_sName;
	CString m_sAddress;
	BOOL m_bMime;
	CString m_sEncodingCharset;
	CString m_sEncodingFriendly;
	BOOL m_bAutoDial;
	CString m_sTo;
	CString m_sCC;
	CString m_sBCC;
	CString m_sSubject;
	CString m_sBody;
	CString m_sFile;
	long m_nTimeout;
	BOOL m_bHTML;
	afx_msg void OnHTMLChanged();
	CString m_sBoundIP;
	afx_msg void OnBoundIPChanged();
	afx_msg short GetLoginMethod();
	afx_msg void SetLoginMethod(short nNewValue);
	afx_msg void Send();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

public:
	// Event maps
	//{{AFX_EVENT(MailSender)
	void FireOnSendProgress(long nBytesCurrent, long nBytesTotal)
		{FireEvent(eventidOnSendProgress,EVENT_PARAM(VTS_I4 VTS_I4), nBytesCurrent, nBytesTotal);}
	//}}AFX_EVENT
private:
	enum {
	//{{AFX_DISP_ID(MailSender)
	eventidOnSendProgress = 1L
	//}}AFX_DISP_ID
	};

private:
	MySMTPConnection* m_pConn;

	CSMTPConnection::LoginMethod m_Authenticate;

	CSMTPMessage* CreateMessage();
};



/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAILSENDER_H__C0802004_FC90_480E_AFE4_70E5CE659D4D__INCLUDED_)
